"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@pnpm/types");
const equals_1 = __importDefault(require("ramda/src/equals"));
exports.default = (lockfile, pkg, importerId) => {
    var _a, _b, _c, _d;
    const importer = lockfile.importers[importerId];
    if (!importer)
        return false;
    if (!(0, equals_1.default)({ ...pkg.devDependencies, ...pkg.dependencies, ...pkg.optionalDependencies }, importer.specifiers)) {
        return false;
    }
    if (!(0, equals_1.default)((_a = pkg.dependenciesMeta) !== null && _a !== void 0 ? _a : {}, (_b = importer.dependenciesMeta) !== null && _b !== void 0 ? _b : {}))
        return false;
    for (const depField of types_1.DEPENDENCIES_FIELDS) {
        const importerDeps = (_c = importer[depField]) !== null && _c !== void 0 ? _c : {};
        const pkgDeps = (_d = pkg[depField]) !== null && _d !== void 0 ? _d : {};
        let pkgDepNames;
        switch (depField) {
            case 'optionalDependencies':
                pkgDepNames = Object.keys(pkgDeps);
                break;
            case 'devDependencies':
                pkgDepNames = Object.keys(pkgDeps)
                    .filter((depName) => ((pkg.optionalDependencies == null) || !pkg.optionalDependencies[depName]) &&
                    ((pkg.dependencies == null) || !pkg.dependencies[depName]));
                break;
            case 'dependencies':
                pkgDepNames = Object.keys(pkgDeps)
                    .filter((depName) => (pkg.optionalDependencies == null) || !pkg.optionalDependencies[depName]);
                break;
            default:
                throw new Error(`Unknown dependency type "${depField}"`);
        }
        if (pkgDepNames.length !== Object.keys(importerDeps).length &&
            pkgDepNames.length !== countOfNonLinkedDeps(importerDeps)) {
            return false;
        }
        for (const depName of pkgDepNames) {
            if (!importerDeps[depName] || importer.specifiers[depName] !== pkgDeps[depName])
                return false;
        }
    }
    return true;
};
function countOfNonLinkedDeps(lockfileDeps) {
    return Object.values(lockfileDeps).filter((ref) => !ref.includes('link:') && !ref.includes('file:')).length;
}
//# sourceMappingURL=satisfiesPackageManifest.js.map